;WIPEOUT6.LSP            Ed Bolton, November 1995

;The startup function makes it self executing after a drawing is
;loaded in AutoCAD.  The line (load "bclean.lsp")  has
;to be added at the end of ACAD.LSP for this to work.
;The line should be deleted from ACAD.LSP afterwards to allow
;normal operations later.


(defun s::startup()
(setvar "CMDECHO" 0)
(bclean)
)


(defun bclean (/ fn A list index i do_it)

(setq fn (getvar "DWGNAME"))

;This command changes the drawing if the drawing is
;"UNNAMED" so the command prompts for the OPEN
;command to be issued later will be the same the first
;time through as in later iterations.

(if (= fn "UNNAMED")
   (command "LINE" "0,0" "1,1" ""))


;The 'active ingredient': 

(if (/= fn "UNNAMED") (progn
   (command "BLOCK" "PETER" "0,0" "W"
      (getvar "EXTMIN")
      (getvar "EXTMAX")
      "")
   (command "WBLOCK" fn "Y" "PETER")))   


;BCLEAN creates the file named PLACE.  PLACE contains the
;location of the drawing list file and an index number.  The 
;index number tells BCLEAN which line in the drawing list
;file to read when it next starts up.  If PLACE doesn't exist
;BCLEAN assumes it has not been run before so it prompts for
;the drawing list and creates PLACE:

(setq A (open "PLACE" "r"))

(if (null A) (progn
   (setq A (open "PLACE" "a"))
   (setq list
      (getstring "Path and filename of drawing list: "))
   (if (null list) (progn
      (close A)
      (command "FILES" "3" "PLACE" "" "")
      (quit)))
   (write-line list A)
   (write-line "1" A)
   (close A)
   (setq A (open "PLACE" "r"))))



;Regardless of whether this is first or nth time around,
;PLACE is now open for reading.  BCLEAN gets the drawing list
;and index number from PLACE:

(setq list (read-line A))
(setq index (read-line A))
(setq i (atoi index))
(close A)


;Here, the index number is used to pick the file:

(setq A (open list "r"))
(repeat i
   (setq do_it (read-line A)))
(close A)



;If BCLEAN has hit the end of the drawing list, PLACE is 
;eliminated and BCLEAN exits AutoCAD:

(if (null do_it) (progn
   (command "FILES" "3" "PLACE" "" "")
   (command "QUIT" "Y")))



;The index number in PLACE is incremented and PLACE is closed.
;This is in preparation for opening the next file, which
;reinitializes AutoLISP.  ACAD.LSP will load BCLEAN on startup
;and the next iteration occurs. BCLEAN will read PLACE to
;know what to do:

(setq i(1+ i))
(setq A (open "PLACE" "w"))
(write-line list A)
(setq index (itoa i))
(write-line index A)
(close A)



;This iteration of BCLEAN now opens a new drawing file, which
;is suicidal:
 
(command "OPEN" "Y" do_it "")
) 

 
     